# for bootstrap building jdk
%global bootstrap           0
#
%global default_jdk         17
# openjdk version
%global openjdkver          1.8.0
# only for jdk 8
%global jdkupdatever        432
# upstream jdk version, openjdkver is not equal to majorver when version little than 9.
%global majorver            8
%global minorver            0
%global fixver              20
%global kona_url            https://github.com/Tencent/TencentKona-%{majorver}

# distro release extra infomation
%global rpmrelease          1
%global buildver            1
%global debug_level         release
%define debug_package       %{nil}

%if %{majorver} == 8
%global tarname             %{version}-GA
%endif
%if %{majorver} == 11
%global tarname             kona%{version}
%endif
%if %{majorver} == 17
%global tarname             TencentKona-%{version}
%endif
%if %{majorver} == 21
%global tarname             TencentKona-%{version}
%endif

%global sourcedir           TencentKona-%{majorver}-%{tarname}

%global vendor_version_string TencentKonaJDK

# architecture setup
# now support x86_64 aarch64 and ppc64le, we will support loongarch64, riscv64 and others in future.
%global aarch64             aarch64 arm64 armv8

%ifarch x86_64
%global jdkarch amd64
%endif
%ifarch %{aarch64}
%global jdkarch aarch64
%endif
%ifarch ppc64le
%global jdkarch ppc64le
%endif

%global sa_arches x86_64 %{aarch64}

# Standard JPackage directories and symbolic links.
%global sdkdir              %{name}-%{version}-%{release}
%global sdkbinpath          %{_jvmdir}/%{sdkdir}/bin
%global jrelnk              jre-%{majorver}-konajdk-%{version}-%{release}.%{_arch}

%if %{majorver} > 8
%global jrebinpath          %{sdkbinpath}
%global jredir              %{sdkdir}
%else
%global jrebinpath          %{_jvmdir}/%{sdkdir}/jre/bin
%global jredir              %{sdkdir}/jre
%endif

%if %majorver < 9
%global jdkimage            j2sdk-image
%else
%global jdkimage            jdk
%endif
# buiding setup
%global release_targets     images docs-zip
%global __jar_repack        0

%global bootjdk             %{_jvmdir}/java
%global jdk_vendor          Tencent Company

# priority must be 7 digits in total. The expression is workarounding tip
%global priority            00000%{minorver}1


# Fix for https://bugzilla.redhat.com/show_bug.cgi?id=1111349.
# See also https://bugzilla.redhat.com/show_bug.cgi?id=1590796
# as to why some libraries *cannot* be excluded. In particular,
# these are:
# libjsig.so, libjava.so, libjawt.so, libjvm.so and libverify.so
%global _privatelibs libatk-wrapper[.]so.*|libattach[.]so.*|libawt_headless[.]so.*|libawt[.]so.*|libawt_xawt[.]so.*|libdt_socket[.]so.*|libfontmanager[.]so.*|libhprof[.]so.*|libinstrument[.]so.*|libj2gss[.]so.*|libj2pcsc[.]so.*|libj2pkcs11[.]so.*|libjaas_unix[.]so.*|libjava_crw_demo[.]so.*|libjavajpeg[.]so.*|libjdwp[.]so.*|libjli[.]so.*|libjsdt[.]so.*|libjsoundalsa[.]so.*|libjsound[.]so.*|liblcms[.]so.*|libmanagement[.]so.*|libmlib_image[.]so.*|libnet[.]so.*|libnio[.]so.*|libnpt[.]so.*|libsaproc[.]so.*|libsctp[.]so.*|libsplashscreen[.]so.*|libsunec[.]so.*|libunpack[.]so.*|libzip[.]so.*|lib[.]so\\(SUNWprivate_.*

%global __provides_exclude ^(%{_privatelibs})$
%global __requires_exclude ^(%{_privatelibs})$



Summary:    JDK Runtime Environment %{majorver}
Name:       java-%{majorver}-konajdk
Version:    %{majorver}.%{minorver}.%{fixver}
Release:    %{rpmrelease}%{?dist}
Group:      Development/Languages
License:    ASL 1.1 and ASL 2.0 and GPL+ and GPLv2 and GPLv2 with exceptions and LGPL+ and LGPLv2 and MPLv1.0 and MPLv1.1 and Public Domain and W3C
URL:        %{kona_url}
Source0:    %{url}/archive/%{tarname}/%{tarname}.tar.gz
%if (%majorver < 9)
Patch3000:  jdk8281098-pr3836-pass_compiler_flags_to_adlc.patch
Patch5000:  konajdk-8.0.9-fix-gc-gcc12.patch
%endif
ExclusiveArch: aarch64 x86_64

%if ! %{bootstrap}
BuildRequires: %{name}-devel
%endif
BuildRequires: make, gcc >= 4.8.3, gcc-c++, pkgconfig, autoconf
BuildRequires: libX11-devel, libXrender-devel, libXtst-devel, libXext-devel, libXt-devel, libXrandr-devel, alsa-lib-devel
BuildRequires: cups-devel, freetype-devel, alsa-lib-devel, fontconfig-devel, giflib-devel, lcms2-devel, libjpeg-devel, libpng-devel, libxslt, gdb, harfbuzz-devel, elfutils-devel, nss-devel, binutils

Requires: fontconfig
Requires: libXcomposite
# for supports pkcs11
Requires: nss
Requires: xorg-x11-fonts-Type1

Requires: %{name}-headless = %{version}-%{release}
OrderWithRequires: %{name}-headless = %{version}-%{release}

Provides: java-%{openjdkver}-openjdk = %{openjdkver}-%{release}
Provides: jre-%{openjdkver}-openjdk = %{openjdkver}-%{release}
Provides: java-%{openjdkver} = %{openjdkver}-%{release}
Provides: jre-%{openjdkver} = %{openjdkver}-%{release}
%if %{majorver} == %{default_jdk}
Provides: java = %{version}-%{release}
Provides: jre = %{version}-%{release}
Provides: java-openjdk = %{version}-%{release}
Provides: jre-openjdk = %{version}-%{release}
%endif

%description
JDK %{majorver} packaged as RPM

%package headless
Summary: JAVA %{majorver} Headless Runtime Environment

Requires: ca-certificates
Requires: javapackages-filesystem
Requires: lksctp-tools
Requires: copy-jdk-configs >= 4.0
OrderWithRequires: copy-jdk-configs
Requires: cups-libs
Requires(post):   alternatives
Requires(postun): alternatives
Suggests: lksctp-tools, pcsc-lite-devel

Provides: java-%{openjdkver}-headless = %{openjdkver}-%{release}
Provides: jre-%{openjdkver}-headless = %{openjdkver}-%{release}
Provides: jre-%{openjdkver}-openjdk-headless = %{openjdkver}-%{release}
Provides: java-%{openjdkver}-openjdk-headless = %{openjdkver}-%{release}
Provides: jre-%{majorver}-konajdk-headless = %{version}-%{release}
%if %{majorver} == %{default_jdk}
Provides: java-openjdk-headless = %{version}-%{release}
Provides: jre-openjdk-headless = %{version}-%{release}
Provides: jre-headless = %{version}-%{release}
Provides: java-headless = %{version}-%{release}
%endif

%description headless
JAVA %{majorver} runtime environment without audio and video support.

%package devel
Summary: JAVA %{majorver} Development Environment

Requires:          %{name} = %{version}-%{release}
OrderWithRequires: %{name}-headless = %{version}-%{release}
Requires(post):   alternatives
Requires(postun): alternatives
Provides: java-sdk-%{openjdkver} = %{openjdkver}-%{release}
Provides: java-%{openjdkver}-openjdk-devel = %{openjdkver}-%{release}
Provides: java-%{openjdkver}-devel = %{openjdkver}-%{release}
Provides: java-sdk-%{openjdkver}-openjdk = %{openjdkver}-%{release}
Provides: java-sdk-%{majorver}-konajdk = %{version}-%{release}
%if %{majorver} == %{default_jdk}
Provides: java-devel-openjdk = %{version}-%{release}
Provides: java-sdk-openjdk = %{version}-%{release}
Provides: java-devel = %{version}-%{release}
Provides: java-sdk = %{version}-%{release}
%endif

%description devel
JAVA %{majorver} development tools.

%if %{majorver} > 8
%package jmods
Summary: JMods for JAVA %{majorver}

# Requires devel package
# as jmods are bytecode, they should be OK without any _isa
Requires: %{name}-devel = %{version}-%{release}
OrderWithRequires: %{name}-headless = %{version}-%{release}
Provides: java-%{openjdkver}-jmods = %{openjdkver}-%{release}
Provides: java-%{openjdkver}-openjdk-jmods = %{openjdkver}-%{release}
%if %majorver == %default_jdk
Provides: java-jmods = %{version}-%{release}
%endif

%description jmods
The JMods for JAVA %{majorver}.
%endif

%package demo
Summary: JAVA %{majorver} Demos
Requires(post):   alternatives
Requires(postun): alternatives
Requires: %{name} = %{version}-%{release}
OrderWithRequires: %{name}-headless = %{version}-%{release}
Provides: java-%{openjdkver}-openjdk-demo = %{openjdkver}-%{release}
Provides: java-%{openjdkver}-demo = %{openjdkver}-%{release}
%if %majorver == %default_jdk
Provides: java-demo = %{version}-%{release}
Provides: java-openjdk-demo = %{version}-%{release}
%endif

%description demo
JAVA %{majorver} demos.

%package src
Summary: JAVA %{majorver} Source Bundle
Requires: %{name}-headless = %{version}-%{release}
Provides: java-%{openjdkver}-src = %{openjdkver}-%{release}
Provides: java-%{openjdkver}-openjdk-src = %{openjdkver}-%{release}
%if %majorver == %default_jdk
Provides: java-src = %{version}-%{release}
Provides: java-openjdk-src = %{version}-%{release}
%endif

%description src
The %{name}-src sub-package contains the complete %{majorver}
class library source code for use by IDE indexers and debuggers.

%package javadoc
Summary: JAVA %{majorver} API documentation
Requires: javapackages-filesystem
OrderWithRequires: %{name}-headless = %{version}-%{release}
Requires(post):   alternatives
Requires(postun): alternatives
BuildArch: noarch
Provides: java-%{openjdkver}-javadoc = %{openjdkver}-%{release}
Provides: java-%{openjdkver}-openjdk-javadoc = %{openjdkver}-%{release}
%if %majorver == %default_jdk
Provides: java-javadoc = %{version}-%{release}
%endif

%description javadoc
JAVA %{majorver} API documentation.

%package javadoc-zip
Summary: JAVA %{majorver} API documentation compressed in a single archive
Requires: javapackages-filesystem
OrderWithRequires: %{name}-headless = %{version}-%{release}
Requires(post):   alternatives
Requires(postun): alternatives
BuildArch: noarch
Provides: java-%{openjdkver}-javadoc-zip = %{openjdkver}-%{release}
Provides: java-%{openjdkver}-openjdk-javadoc-zip = %{openjdkver}-%{release}
%if %majorver == %default_jdk
Provides: java-javadoc-zip = %{version}-%{release}
%endif

%description javadoc-zip
JAVA %{majorver} API documentation compressed in a single archive.



%prep
%autosetup -n %{sourcedir} -p1
chmod +x configure



%build
%global _lto_cflags           %{nil}
%global ourflags              %(echo %optflags | sed -e 's|-Wall|-Wformat -Wno-cpp|' | sed -r -e 's|-O[0-9]*||')
%global ourcppflags           %(echo %ourflags | sed -e 's|-fexceptions||')

export EXTRA_CFLAGS="%ourcppflags -Wno-error -Wno-error=maybe-uninitialized"
export EXTRA_CPP_FLAGS="%ourcppflags -Wno-error=maybe-uninitialized"
export EXTRA_ASFLAGS="${EXTRA_CFLAGS} -Wa,--generate-missing-build-notes=yes"

# start to config and build jdk
mkdir -p %{debug_level}
pushd %{debug_level}

bash ../configure \
    --with-vendor-name="%{jdk_vendor}" \
    --with-native-debug-symbols=internal \
    --with-vendor-url="%{url}" \
    --with-vendor-bug-url="%{url}/issues" \
    --with-vendor-vm-bug-url="%{url}/issues" \
    --with-boot-jdk=%{bootjdk} \
    --with-debug-level=%{debug_level} \
    --enable-unlimited-crypto \
    --with-zlib=system \
    --with-giflib=system \
    --with-extra-cxxflags="${EXTRA_CPP_FLAGS}" \
    --with-extra-cflags="${EXTRA_CFLAGS}" \
    --with-extra-asflags="${EXTRA_ASFLAGS}" \
    --with-extra-ldflags="%{__global_ldflags}" \
%if (%majorver < 9)
    --enable-jfr \
    --with-milestone=fcs \
    --with-update-version=%{jdkupdatever} \
    --with-build-number=%{buildver}
%else
%ifarch x86_64
    --with-jvm-features=zgc \
%else
    --with-jvm-features=-zgc \
%endif
    --with-libjpeg=system \
    --with-libpng=system \
    --with-lcms=system \
    --with-version-pre=ga \
    --without-version-opt \
    --with-vendor-version-string="%{vendor_version_string}" \
    --disable-javac-server \
    --disable-warnings-as-errors \
    --with-version-build=%{buildver}
%endif


make \
%if (%majorver > 8)
  WARNINGS_ARE_ERRORS="-Wno-error" \
  CFLAGS_WARNINGS_ARE_ERRORS="-Wno-error" \
%endif
%{release_targets}

popd
# end building



%install
pushd %{debug_level}
imagepath="images/%{jdkimage}"

%if (%majorver < 9)
if [ -d ${imagepath} ] ; then
  find ${imagepath} -iname '*.jar' -exec chmod ugo+r {} \;
  chmod ugo+r ${imagepath}/lib/ct.sym

  # remove redundant *diz and *debuginfo files
  find ${imagepath} -iname '*.diz' -exec rm -v {} \;
  find ${imagepath} -iname '*.debuginfo' -exec rm -v {} \;
fi
%else
if [ -d ${imagepath} ] ; then
  # Build screws up permissions on binaries
  # https://bugs.openjdk.java.net/browse/JDK-8173610
  find ${imagepath} -iname '*.so' -exec ls -al {} \;
  find ${imagepath}/bin/ -exec ls -al {} \;

  find ${imagepath} -iname '*.so' -exec chmod +x {} \;
  find ${imagepath}/bin/ -exec chmod +x {} \;
fi
mv images/docs/ .
%endif

pushd ${imagepath}
# Install main files.
install -d -m 755 %{buildroot}%{_jvmdir}/%{sdkdir}/
cp -a bin include lib demo %{buildroot}%{_jvmdir}/%{sdkdir}/
%if %{majorver} < 9
cp -a jre sample src.zip ASSEMBLY_EXCEPTION LICENSE THIRD_PARTY_README %{buildroot}%{_jvmdir}/%{sdkdir}/
%else
cp -a conf jmods legal release %{buildroot}%{_jvmdir}/%{sdkdir}/
%endif

# Install manpage files
install -d -m 755 %{buildroot}%{_mandir}/man1
for manpage in man/man1/*
do
  # Convert man pages to UTF8 encoding
  iconv -f ISO_8859-1 -t UTF8 $manpage -o $manpage.tmp
  mv -f $manpage.tmp $manpage

  install -m 644 -p $manpage %{buildroot}%{_mandir}/man1/$(basename $manpage .1)-%{sdkdir}.1
done

# moving config files to /etc
%if %{majorver} < 9
mkdir -p %{buildroot}%{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/policy/unlimited/
mkdir -p %{buildroot}%{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/policy/limited/
for file in \
  lib/security/cacerts \
  lib/security/policy/unlimited/US_export_policy.jar \
  lib/security/policy/unlimited/local_policy.jar \
  lib/security/policy/limited/US_export_policy.jar \
  lib/security/policy/limited/local_policy.jar \
  lib/security/java.policy \
  lib/security/java.security \
  lib/security/blacklisted.certs \
  lib/logging.properties \
  lib/calendars.properties \
  lib/net.properties
do
  cp -a  %{buildroot}%{_jvmdir}/%{jredir}/$file  %{buildroot}%{_sysconfdir}/java/%{name}/%{sdkdir}/$file
  ln -sf  %{_sysconfdir}/java/%{name}/%{sdkdir}/$file  %{buildroot}%{_jvmdir}/%{jredir}/$file
done
%else
mkdir -p %{buildroot}/%{_sysconfdir}/java/%{name}/%{sdkdir}
mkdir -p %{buildroot}/%{_sysconfdir}/java/%{name}/%{sdkdir}/lib
mv %{buildroot}/%{_jvmdir}/%{sdkdir}/conf/  %{buildroot}/%{_sysconfdir}/java/%{name}/%{sdkdir}
mv %{buildroot}/%{_jvmdir}/%{sdkdir}/lib/security  %{buildroot}/%{_sysconfdir}/java/%{name}/%{sdkdir}/lib
pushd %{buildroot}/%{_jvmdir}/%{sdkdir}
  ln -s %{_sysconfdir}/java/%{name}/%{sdkdir}/conf  ./conf
popd
pushd %{buildroot}/%{_jvmdir}/%{sdkdir}/lib
  ln -s %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security  ./security
popd
%endif
popd

install -d -m 755 %{buildroot}%{_javadocdir}/%{sdkdir}/
cp -a docs/* %{buildroot}%{_javadocdir}/%{sdkdir}/
cp -a bundles/*.zip %{buildroot}%{_javadocdir}/%{sdkdir}.zip
popd

# Install /etc/.java/.systemPrefs/ directory
mkdir -p %{buildroot}%{_sysconfdir}/.java/.systemPrefs

pushd %{buildroot}%{_jvmdir}
%if %{majorver} < 9
  ln -sf %{jredir} %{jrelnk}
%else
  ln -sf %{sdkdir} %{jrelnk}
%endif
popd

find %{buildroot}%{_jvmdir}/%{sdkdir}/ -name "*.so" -exec chmod 755 {} \; ; 
find %{buildroot}%{_jvmdir}/%{sdkdir}/ -type d -exec chmod 755 {} \; ; 
find %{buildroot}%{_jvmdir}/%{sdkdir}/ -name "ASSEMBLY_EXCEPTION" -exec chmod 644 {} \; ; 
find %{buildroot}%{_jvmdir}/%{sdkdir}/ -name "LICENSE" -exec chmod 644 {} \; ; 
find %{buildroot}%{_jvmdir}/%{sdkdir}/ -name "THIRD_PARTY_README" -exec chmod 644 {} \; ;
chmod 644 %{buildroot}%{_mandir}/man1/*



%define save_alternatives() %{expand:
  # warning! alternatives are localised!
  # LANG=cs_CZ.UTF-8  alternatives --display java | head
  # LANG=en_US.UTF-8  alternatives --display java | head
  function nonLocalisedAlternativesDisplayOfMaster() {
    LANG=en_US.UTF-8 alternatives --display "$MASTER"
  }
  function headOfAbove() {
    nonLocalisedAlternativesDisplayOfMaster | head -n $1
  }
  MASTER="%{1}"
  LOCAL_LINK="%{2}"
  FAMILY="%{3}"
  rm -f %{_localstatedir}/lib/rpm-state/"$MASTER"_$FAMILY > /dev/null
  if nonLocalisedAlternativesDisplayOfMaster > /dev/null ; then
      if headOfAbove 1 | grep -q manual ; then
        if headOfAbove 2 | tail -n 1 | grep -q %{compatiblename} ; then
           headOfAbove 2  > %{_localstatedir}/lib/rpm-state/"$MASTER"_"$FAMILY"
        fi
      fi
  fi
}

%define save_and_remove_alternatives() %{expand:
  upgrade1_uninstal0=%{3}
  if [ "0$upgrade1_uninstal0" -gt 0 ] ; then # removal of this condition will cause persistence between uninstall
    %{save_alternatives %{1} %{2} %{4}}
  fi
  alternatives --remove  "%{1}" "%{2}"
}

%define set_if_needed_alternatives() %{expand:
  MASTER="%{1}"
  FAMILY="%{2}"
  ALTERNATIVES_FILE="%{_localstatedir}/lib/rpm-state/$MASTER"_"$FAMILY"
  if [ -e  "$ALTERNATIVES_FILE" ] ; then
    rm "$ALTERNATIVES_FILE"
    alternatives --set $MASTER $FAMILY
  fi
}

%post headless
%ifarch %{sa_arches}
%{jrebinpath}/java -Xshare:dump >/dev/null 2>/dev/null
%endif
exit 0

%postun headless
post_state=$1
%{save_and_remove_alternatives  java                     %{jrebinpath}/java $post_state %{name}.%{_arch}}
%{save_and_remove_alternatives  jre_konajdk              %{_jvmdir}/%{jredir} $post_state %{name}.%{_arch}}
%{save_and_remove_alternatives  jre_%{majorver}          %{_jvmdir}/%{jredir} $post_state %{name}.%{_arch}}
%if "%{openjdkver}" == "1.8.0"
%{save_and_remove_alternatives  jre_1.8.0         %{_jvmdir}/%{jredir} $post_state %{name}.%{_arch}}
%endif
%{save_and_remove_alternatives  jre_%{majorver}_konajdk  %{_jvmdir}/%{jrelnk} $post_state %{name}.%{_arch}}
exit 0

%posttrans headless
PRIORITY=%{priority}
alternatives \
  --install %{_bindir}/java java %{jrebinpath}/java $PRIORITY  --family %{name}.%{_arch} \
%if %{majorver} == 8
  --slave %{_jvmdir}/jre jre %{_jvmdir}/%{jredir} \
  --slave %{_bindir}/orbd orbd %{jrebinpath}/orbd \
  --slave %{_bindir}/policytool policytool %{jrebinpath}/policytool \
  --slave %{_bindir}/tnameserv tnameserv %{jrebinpath}/tnameserv \
  --slave %{_bindir}/servertool servertool %{jrebinpath}/servertool \
  --slave %{_mandir}/man1/java.1.gz java.1.gz \
  %{_mandir}/man1/java-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jjs.1.gz jjs.1.gz \
  %{_mandir}/man1/jjs-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/keytool.1.gz keytool.1.gz \
  %{_mandir}/man1/keytool-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/orbd.1.gz orbd.1.gz \
  %{_mandir}/man1/orbd-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/pack200.1.gz pack200.1.gz \
  %{_mandir}/man1/pack200-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/rmid.1.gz rmid.1.gz \
  %{_mandir}/man1/rmid-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/rmiregistry.1.gz rmiregistry.1.gz \
  %{_mandir}/man1/rmiregistry-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/servertool.1.gz servertool.1.gz \
  %{_mandir}/man1/servertool-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/tnameserv.1.gz tnameserv.1.gz \
  %{_mandir}/man1/tnameserv-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/policytool.1.gz policytool.1.gz \
  %{_mandir}/man1/policytool-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/unpack200.1.gz unpack200.1.gz \
  %{_mandir}/man1/unpack200-%{sdkdir}.1.gz \
%endif
%if %{majorver} == 11
  --slave %{_jvmdir}/jre jre %{_jvmdir}/%{sdkdir} \
  --slave %{_bindir}/jjs jjs %{jrebinpath}/jjs \
  --slave %{_bindir}/rmid rmid %{jrebinpath}/rmid \
  --slave %{_bindir}/pack200 pack200 %{jrebinpath}/pack200 \
  --slave %{_bindir}/unpack200 unpack200 %{jrebinpath}/unpack200 \
  --slave %{_mandir}/man1/java.1.gz java.1.gz \
  %{_mandir}/man1/java-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jjs.1.gz jjs.1.gz \
  %{_mandir}/man1/jjs-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/keytool.1.gz keytool.1.gz \
  %{_mandir}/man1/keytool-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/pack200.1.gz pack200.1.gz \
  %{_mandir}/man1/pack200-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/rmid.1.gz rmid.1.gz \
  %{_mandir}/man1/rmid-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/rmiregistry.1.gz rmiregistry.1.gz \
  %{_mandir}/man1/rmiregistry-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/unpack200.1.gz unpack200.1.gz \
  %{_mandir}/man1/unpack200-%{sdkdir}.1.gz \
%endif
%if %{majorver} == 17
  --slave %{_jvmdir}/jre jre %{_jvmdir}/%{sdkdir} \
  --slave %{_mandir}/man1/java.1.gz java.1.gz \
  %{_mandir}/man1/java-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/keytool.1.gz keytool.1.gz \
  %{_mandir}/man1/keytool-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/rmiregistry.1.gz rmiregistry.1.gz \
  %{_mandir}/man1/rmiregistry-%{sdkdir}.1.gz \
%endif
  --slave %{_bindir}/keytool keytool %{jrebinpath}/keytool \
  --slave %{_bindir}/rmiregistry rmiregistry %{jrebinpath}/rmiregistry

%{set_if_needed_alternatives java %{name}.%{_arch}}


for X in konajdk %{majorver} ; do
  key=jre_${X}
  alternatives --install %{_jvmdir}/jre-${X} ${key} %{_jvmdir}/%{jredir} $PRIORITY --family %{name}.%{_arch}
  %{set_if_needed_alternatives java %{name}.%{_arch}}
done

%if "%{openjdkver}" == "1.8.0"
  alternatives --install %{_jvmdir}/jre-1.8.0 jre_1.8.0 %{_jvmdir}/%{jredir} $PRIORITY --family %{name}.%{_arch}
  %{set_if_needed_alternatives java %{name}.%{_arch}} 
%endif

key=jre_%{majorver}_konajdk
alternatives --install %{_jvmdir}/jre-%{majorver}-konajdk ${key} %{_jvmdir}/%{jrelnk} $PRIORITY  --family %{name}.%{_arch}
%{set_if_needed_alternatives java %{name}.%{_arch}}
exit 0

%postun devel
post_state=$1
%{save_and_remove_alternatives  javac %{sdkbinpath}/javac $post_state %{name}.%{_arch}}
%{save_and_remove_alternatives  java_sdk_konajdk %{_jvmdir}/%{sdkdir} $post_state %{name}.%{_arch}}
%{save_and_remove_alternatives  java_sdk_%{majorver} %{_jvmdir}/%{sdkdir} $post_state %{name}.%{_arch}}
%if "%{openjdkver}" == "1.8.0"
%{save_and_remove_alternatives  java_sdk_1.8.0 %{_jvmdir}/%{sdkdir} $post_state %{name}.%{_arch}}
%endif
%{save_and_remove_alternatives  java_sdk_%{majorver} %{_jvmdir}/%{sdkdir} $post_state %{name}.%{_arch}}
%{save_and_remove_alternatives  java_sdk_%{majorver}_konajdk %{_jvmdir}/%{sdkdir} $post_state %{name}.%{_arch}}
exit 0

%posttrans devel
PRIORITY=%{priority}
alternatives \
  --install %{_bindir}/javac javac %{sdkbinpath}/javac $PRIORITY  --family %{name}.%{_arch} \
  --slave %{_jvmdir}/java java_sdk %{_jvmdir}/%{sdkdir} \
%if %{majorver} == 8
  --slave %{_bindir}/appletviewer appletviewer %{sdkbinpath}/appletviewer \
  --slave %{_bindir}/clhsdb clhsdb %{sdkbinpath}/clhsdb \
  --slave %{_bindir}/extcheck extcheck %{sdkbinpath}/extcheck \
  --slave %{_bindir}/hsdb hsdb %{sdkbinpath}/hsdb \
  --slave %{_bindir}/idlj idlj %{sdkbinpath}/idlj \
  --slave %{_bindir}/javah javah %{sdkbinpath}/javah \
  --slave %{_bindir}/java-rmi.cgi java-rmi.cgi %{sdkbinpath}/java-rmi.cgi \
  --slave %{_bindir}/jhat jhat %{sdkbinpath}/jhat \
  --slave %{_bindir}/jsadebugd jsadebugd %{sdkbinpath}/jsadebugd \
  --slave %{_bindir}/rmic rmic %{sdkbinpath}/rmic \
  --slave %{_bindir}/native2ascii native2ascii %{sdkbinpath}/native2ascii \
  --slave %{_bindir}/schemagen schemagen %{sdkbinpath}/schemagen \
  --slave %{_bindir}/wsgen wsgen %{sdkbinpath}/wsgen \
  --slave %{_bindir}/wsimport wsimport %{sdkbinpath}/wsimport \
  --slave %{_bindir}/xjc xjc %{sdkbinpath}/xjc \
  --slave %{_mandir}/man1/appletviewer.1.gz appletviewer.1.gz \
  %{_mandir}/man1/appletviewer-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/extcheck.1.gz extcheck.1.gz \
  %{_mandir}/man1/extcheck-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/idlj.1.gz idlj.1.gz \
  %{_mandir}/man1/idlj-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jar.1.gz jar.1.gz \
  %{_mandir}/man1/jar-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jarsigner.1.gz jarsigner.1.gz \
  %{_mandir}/man1/jarsigner-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javac.1.gz javac.1.gz \
  %{_mandir}/man1/javac-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javadoc.1.gz javadoc.1.gz \
  %{_mandir}/man1/javadoc-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javah.1.gz javah.1.gz \
  %{_mandir}/man1/javah-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javap.1.gz javap.1.gz \
  %{_mandir}/man1/javap-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jcmd.1.gz jcmd.1.gz \
  %{_mandir}/man1/jcmd-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jconsole.1.gz jconsole.1.gz \
  %{_mandir}/man1/jconsole-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jdb.1.gz jdb.1.gz \
  %{_mandir}/man1/jdb-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jdeps.1.gz jdeps.1.gz \
  %{_mandir}/man1/jdeps-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jhat.1.gz jhat.1.gz \
  %{_mandir}/man1/jhat-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jinfo.1.gz jinfo.1.gz \
  %{_mandir}/man1/jinfo-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jmap.1.gz jmap.1.gz \
  %{_mandir}/man1/jmap-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jps.1.gz jps.1.gz \
  %{_mandir}/man1/jps-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jrunscript.1.gz jrunscript.1.gz \
  %{_mandir}/man1/jrunscript-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jsadebugd.1.gz jsadebugd.1.gz \
  %{_mandir}/man1/jsadebugd-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jstack.1.gz jstack.1.gz \
  %{_mandir}/man1/jstack-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jstat.1.gz jstat.1.gz \
  %{_mandir}/man1/jstat-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jstatd.1.gz jstatd.1.gz \
  %{_mandir}/man1/jstatd-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/native2ascii.1.gz native2ascii.1.gz \
  %{_mandir}/man1/native2ascii-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/rmic.1.gz rmic.1.gz \
  %{_mandir}/man1/rmic-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/schemagen.1.gz schemagen.1.gz \
  %{_mandir}/man1/schemagen-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/serialver.1.gz serialver.1.gz \
  %{_mandir}/man1/serialver-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/wsgen.1.gz wsgen.1.gz \
  %{_mandir}/man1/wsgen-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/wsimport.1.gz wsimport.1.gz \
  %{_mandir}/man1/wsimport-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/xjc.1.gz xjc.1.gz \
  %{_mandir}/man1/xjc-%{sdkdir}.1.gz \
%endif
%if %{majorver} > 8
%if %{majorver} == 11
  --slave %{_bindir}/jaotc jaotc %{sdkbinpath}/jaotc \
  --slave %{_bindir}/rmic rmic %{sdkbinpath}/rmic \
  --slave %{_mandir}/man1/jar.1.gz jar.1.gz \
  %{_mandir}/man1/jar-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jarsigner.1.gz jarsigner.1.gz \
  %{_mandir}/man1/jarsigner-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javac.1.gz javac.1.gz \
  %{_mandir}/man1/javac-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javadoc.1.gz javadoc.1.gz \
  %{_mandir}/man1/javadoc-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javap.1.gz javap.1.gz \
  %{_mandir}/man1/javap-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jcmd.1.gz jcmd.1.gz \
  %{_mandir}/man1/jcmd-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jconsole.1.gz jconsole.1.gz \
  %{_mandir}/man1/jconsole-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jdb.1.gz jdb.1.gz \
  %{_mandir}/man1/jdb-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jdeps.1.gz jdeps.1.gz \
  %{_mandir}/man1/jdeps-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jinfo.1.gz jinfo.1.gz \
  %{_mandir}/man1/jinfo-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jmap.1.gz jmap.1.gz \
  %{_mandir}/man1/jmap-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jps.1.gz jps.1.gz \
  %{_mandir}/man1/jps-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jrunscript.1.gz jrunscript.1.gz \
  %{_mandir}/man1/jrunscript-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jstack.1.gz jstack.1.gz \
  %{_mandir}/man1/jstack-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jstat.1.gz jstat.1.gz \
  %{_mandir}/man1/jstat-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jstatd.1.gz jstatd.1.gz \
  %{_mandir}/man1/jstatd-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/rmic.1.gz rmic.1.gz \
  %{_mandir}/man1/rmic-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/serialver.1.gz serialver.1.gz \
  %{_mandir}/man1/serialver-%{sdkdir}.1.gz \
%endif
%if %{majorver} == 17
  --slave %{_bindir}/jpackage jpackage %{sdkbinpath}/jpackage \
  --slave %{_mandir}/man1/jar.1.gz jar.1.gz \
  %{_mandir}/man1/jar-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jarsigner.1.gz jarsigner.1.gz \
  %{_mandir}/man1/jarsigner-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javac.1.gz javac.1.gz \
  %{_mandir}/man1/javac-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javadoc.1.gz javadoc.1.gz \
  %{_mandir}/man1/javadoc-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/javap.1.gz javap.1.gz \
  %{_mandir}/man1/javap-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jcmd.1.gz jcmd.1.gz \
  %{_mandir}/man1/jcmd-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jconsole.1.gz jconsole.1.gz \
  %{_mandir}/man1/jconsole-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jdb.1.gz jdb.1.gz \
  %{_mandir}/man1/jdb-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jdeprscan.1.gz jdeprscan.1.gz \
  %{_mandir}/man1/jdeprscan-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jdeps.1.gz jdeps.1.gz \
  %{_mandir}/man1/jdeps-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jfr.1.gz jfr.1.gz \
  %{_mandir}/man1/jfr-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jhsdb.1.gz jhsdb.1.gz \
  %{_mandir}/man1/jhsdb-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jinfo.1.gz jinfo.1.gz \
  %{_mandir}/man1/jinfo-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jlink.1.gz jlink.1.gz \
  %{_mandir}/man1/jlink-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jmap.1.gz jmap.1.gz \
  %{_mandir}/man1/jmap-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jmod.1.gz jmod.1.gz \
  %{_mandir}/man1/jmod-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jpackage.1.gz jpackage.1.gz \
  %{_mandir}/man1/jpackage-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jps.1.gz jps.1.gz \
  %{_mandir}/man1/jps-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jrunscript.1.gz jrunscript.1.gz \
  %{_mandir}/man1/jrunscript-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jshell.1.gz jshell.1.gz \
  %{_mandir}/man1/jshell-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jstack.1.gz jstack.1.gz \
  %{_mandir}/man1/jstack-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jstat.1.gz jstat.1.gz \
  %{_mandir}/man1/jstat-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/jstatd.1.gz jstatd.1.gz \
  %{_mandir}/man1/jstatd-%{sdkdir}.1.gz \
  --slave %{_mandir}/man1/serialver.1.gz serialver.1.gz \
  %{_mandir}/man1/serialver-%{sdkdir}.1.gz \
%endif
  --slave %{_bindir}/jdeprscan jdeprscan %{sdkbinpath}/jdeprscan \
  --slave %{_bindir}/jhsdb jhsdb %{sdkbinpath}/jhsdb \
  --slave %{_bindir}/jimage jimage %{sdkbinpath}/jimage \
  --slave %{_bindir}/jlink jlink %{sdkbinpath}/jlink \
  --slave %{_bindir}/jmod jmod %{sdkbinpath}/jmod \
  --slave %{_bindir}/jshell jshell %{sdkbinpath}/jshell \
%endif
  --slave %{_bindir}/jar jar %{sdkbinpath}/jar \
  --slave %{_bindir}/jarsigner jarsigner %{sdkbinpath}/jarsigner \
  --slave %{_bindir}/javadoc javadoc %{sdkbinpath}/javadoc \
  --slave %{_bindir}/javap javap %{sdkbinpath}/javap \
  --slave %{_bindir}/jcmd jcmd %{sdkbinpath}/jcmd \
  --slave %{_bindir}/jconsole jconsole %{sdkbinpath}/jconsole \
  --slave %{_bindir}/jdb jdb %{sdkbinpath}/jdb \
  --slave %{_bindir}/jdeps jdeps %{sdkbinpath}/jdeps \
  --slave %{_bindir}/jfr jfr %{sdkbinpath}/jfr \
  --slave %{_bindir}/jinfo jinfo %{sdkbinpath}/jinfo \
  --slave %{_bindir}/jmap jmap %{sdkbinpath}/jmap \
  --slave %{_bindir}/jps jps %{sdkbinpath}/jps \
  --slave %{_bindir}/jrunscript jrunscript %{sdkbinpath}/jrunscript \
  --slave %{_bindir}/jstack jstack %{sdkbinpath}/jstack \
  --slave %{_bindir}/jstat jstat %{sdkbinpath}/jstat \
  --slave %{_bindir}/jstatd jstatd %{sdkbinpath}/jstatd \
  --slave %{_bindir}/serialver serialver %{sdkbinpath}/serialver

%{set_if_needed_alternatives  javac %{name}.%{_arch}}

for X in konajdk %{majorver} ; do
  key=java_sdk_${X}
  alternatives --install %{_jvmdir}/java-${X} ${key} %{_jvmdir}/%{sdkdir} $PRIORITY  --family %{name}.%{_arch}
  %{set_if_needed_alternatives javac %{name}.%{_arch}}
done

%if "%{openjdkver}" == "1.8.0"
  alternatives --install %{_jvmdir}/java-1.8.0 java_sdk_1.8.0 %{_jvmdir}/%{sdkdir} $PRIORITY --family %{name}.%{_arch}
  %{set_if_needed_alternatives javac %{name}.%{_arch}}
%endif

key=java_sdk_%{majorver}_konajdk
alternatives --install %{_jvmdir}/%{name} ${key} %{_jvmdir}/%{sdkdir} $PRIORITY  --family %{name}.%{_arch}
%{set_if_needed_alternatives  javac %{name}.%{_arch}}
exit 0

%posttrans javadoc
PRIORITY=%{priority}
alternatives --install %{_javadocdir}/java javadocdir %{_javadocdir}/%{sdkdir}/api $PRIORITY  --family %{name}
%{set_if_needed_alternatives  javadocdir %{name}}
exit 0

%postun javadoc
post_state=$1
%{save_and_remove_alternatives  javadocdir  %{_javadocdir}/%{sdkdir}/api $post_state %{name}}
exit 0

%posttrans javadoc-zip
PRIORITY=%{priority}
alternatives --install %{_javadocdir}/java-zip javadoczip %{_javadocdir}/%{sdkdir}.zip $PRIORITY  --family %{name}
%{set_if_needed_alternatives  javadoczip %{name}}
exit 0

%postun javadoc-zip
post_state=$1
%{save_and_remove_alternatives  javadoczip  %{_javadocdir}/%{sdkdir}.zip $post_state %{name}}
exit 0


%files
%if %majorver < 9
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libsplashscreen.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libawt_xawt.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjawt.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjsoundalsa.so
%{_jvmdir}/%{sdkdir}/jre/bin/policytool
%ghost %{_bindir}/policytool
%else
%{_jvmdir}/%{sdkdir}/lib/libsplashscreen.so
%{_jvmdir}/%{sdkdir}/lib/libawt_xawt.so
%{_jvmdir}/%{sdkdir}/lib/libjawt.so
%endif

%files headless
# headless of jdk 8
%if %{majorver} < 9
%defattr(-,root,root,-)
%dir %{_sysconfdir}/.java/.systemPrefs
%dir %{_sysconfdir}/.java
%license %{_jvmdir}/%{sdkdir}/jre/ASSEMBLY_EXCEPTION
%license %{_jvmdir}/%{sdkdir}/jre/LICENSE
%license %{_jvmdir}/%{sdkdir}/jre/THIRD_PARTY_README
%dir %{_jvmdir}/%{sdkdir}
%{_jvmdir}/%{jrelnk}
%dir %{_jvmdir}/%{sdkdir}/jre/lib/security
%{_jvmdir}/%{sdkdir}/jre/lib/security/cacerts
%dir %{_jvmdir}/%{sdkdir}/jre
%dir %{_jvmdir}/%{sdkdir}/jre/bin
%dir %{_jvmdir}/%{sdkdir}/jre/lib
%{_jvmdir}/%{sdkdir}/jre/bin/java
%{_jvmdir}/%{sdkdir}/jre/bin/jjs
%{_jvmdir}/%{sdkdir}/jre/bin/keytool
%{_jvmdir}/%{sdkdir}/jre/bin/orbd
%{_jvmdir}/%{sdkdir}/jre/bin/pack200
%{_jvmdir}/%{sdkdir}/jre/bin/rmid
%{_jvmdir}/%{sdkdir}/jre/bin/rmiregistry
%{_jvmdir}/%{sdkdir}/jre/bin/servertool
%{_jvmdir}/%{sdkdir}/jre/bin/tnameserv
%{_jvmdir}/%{sdkdir}/jre/bin/unpack200
%dir %{_jvmdir}/%{sdkdir}/jre/lib/security/policy/unlimited/
%dir %{_jvmdir}/%{sdkdir}/jre/lib/security/policy/limited/
%dir %{_jvmdir}/%{sdkdir}/jre/lib/security/policy/
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/policy/unlimited/US_export_policy.jar
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/policy/unlimited/local_policy.jar
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/policy/limited/US_export_policy.jar
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/policy/limited/local_policy.jar
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/java.policy
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/java.security
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/blacklisted.certs
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/logging.properties
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/calendars.properties
%{_jvmdir}/%{sdkdir}/jre/lib/security/policy/unlimited/US_export_policy.jar
%{_jvmdir}/%{sdkdir}/jre/lib/security/policy/unlimited/local_policy.jar
%{_jvmdir}/%{sdkdir}/jre/lib/security/policy/limited/US_export_policy.jar
%{_jvmdir}/%{sdkdir}/jre/lib/security/policy/limited/local_policy.jar
%{_jvmdir}/%{sdkdir}/jre/lib/security/java.policy
%{_jvmdir}/%{sdkdir}/jre/lib/security/java.security
%{_jvmdir}/%{sdkdir}/jre/lib/security/blacklisted.certs
%{_jvmdir}/%{sdkdir}/jre/lib/logging.properties
%{_jvmdir}/%{sdkdir}/jre/lib/calendars.properties
%{_mandir}/man1/java-%{sdkdir}.1*
%{_mandir}/man1/jjs-%{sdkdir}.1*
%{_mandir}/man1/keytool-%{sdkdir}.1*
%{_mandir}/man1/orbd-%{sdkdir}.1*
%{_mandir}/man1/pack200-%{sdkdir}.1*
%{_mandir}/man1/rmid-%{sdkdir}.1*
%{_mandir}/man1/rmiregistry-%{sdkdir}.1*
%{_mandir}/man1/servertool-%{sdkdir}.1*
%{_mandir}/man1/tnameserv-%{sdkdir}.1*
%{_mandir}/man1/unpack200-%{sdkdir}.1*
%{_mandir}/man1/policytool-%{sdkdir}.1*
%ifarch %{sa_arches}
%attr(444, root, root) %ghost %{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/server/classes.jsa
%endif
%dir %{_sysconfdir}/java/%{name}
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/lib
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security
%{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/cacerts
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/policy
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/policy/limited
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/policy/unlimited
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/server/
%dir %{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}
%dir %{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/jli
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/jli/libjli.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/jvm.cfg
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libattach.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libawt.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjpeg.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libawt.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libawt_headless.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libdt_socket.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libfontmanager.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libhprof.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libinstrument.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libj2gss.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libj2pcsc.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libj2pkcs11.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjaas_unix.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjava.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjava_crw_demo.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjdwp.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjsdt.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjsig.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libjsound.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/liblcms.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libmanagement.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libmlib_image.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libnet.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libnio.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libnpt.so
%ifarch %{sa_arches}
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libsaproc.so
%endif
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libsctp.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libsunec.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libunpack.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libverify.so
%{_jvmdir}/%{sdkdir}/jre/lib/%{jdkarch}/libzip.so
%{_jvmdir}/%{sdkdir}/jre/lib/charsets.jar
%{_jvmdir}/%{sdkdir}/jre/lib/classlist
%{_jvmdir}/%{sdkdir}/jre/lib/content-types.properties
%{_jvmdir}/%{sdkdir}/jre/lib/currency.data
%{_jvmdir}/%{sdkdir}/jre/lib/flavormap.properties
%{_jvmdir}/%{sdkdir}/jre/lib/hijrah-config-umalqura.properties
%{_jvmdir}/%{sdkdir}/jre/lib/images/cursors/*
%{_jvmdir}/%{sdkdir}/jre/lib/jce.jar
%{_jvmdir}/%{sdkdir}/jre/lib/jexec
%{_jvmdir}/%{sdkdir}/jre/lib/jsse.jar
%{_jvmdir}/%{sdkdir}/jre/lib/jvm.hprof.txt
%{_jvmdir}/%{sdkdir}/jre/lib/meta-index
%{_jvmdir}/%{sdkdir}/jre/lib/net.properties
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/net.properties
%{_jvmdir}/%{sdkdir}/jre/lib/psfont.properties.ja
%{_jvmdir}/%{sdkdir}/jre/lib/psfontj2d.properties
%{_jvmdir}/%{sdkdir}/jre/lib/resources.jar
%{_jvmdir}/%{sdkdir}/jre/lib/rt.jar
%{_jvmdir}/%{sdkdir}/jre/lib/sound.properties
%{_jvmdir}/%{sdkdir}/jre/lib/tzdb.dat
%{_jvmdir}/%{sdkdir}/jre/lib/management-agent.jar
%{_jvmdir}/%{sdkdir}/jre/lib/management/*
%{_jvmdir}/%{sdkdir}/jre/lib/cmm/*
%{_jvmdir}/%{sdkdir}/jre/lib/ext/cldrdata.jar
%{_jvmdir}/%{sdkdir}/jre/lib/ext/dnsns.jar
%{_jvmdir}/%{sdkdir}/jre/lib/ext/jaccess.jar
%{_jvmdir}/%{sdkdir}/jre/lib/ext/localedata.jar
%{_jvmdir}/%{sdkdir}/jre/lib/ext/meta-index
%{_jvmdir}/%{sdkdir}/jre/lib/ext/nashorn.jar
%{_jvmdir}/%{sdkdir}/jre/lib/ext/sunec.jar
%{_jvmdir}/%{sdkdir}/jre/lib/ext/sunjce_provider.jar
%{_jvmdir}/%{sdkdir}/jre/lib/ext/sunpkcs11.jar
%{_jvmdir}/%{sdkdir}/jre/lib/ext/zipfs.jar
%{_jvmdir}/%{sdkdir}/jre/lib/jfr.jar
%{_jvmdir}/%{sdkdir}/jre/lib/jfr/default.jfc
%{_jvmdir}/%{sdkdir}/jre/lib/jfr/profile.jfc
%dir %{_jvmdir}/%{sdkdir}/jre/lib/images
%dir %{_jvmdir}/%{sdkdir}/jre/lib/images/cursors
%dir %{_jvmdir}/%{sdkdir}/jre/lib/management
%dir %{_jvmdir}/%{sdkdir}/jre/lib/cmm
%dir %{_jvmdir}/%{sdkdir}/jre/lib/ext
%dir %{_jvmdir}/%{sdkdir}/jre/lib/jfr
%ghost %{_bindir}/java
%ghost %{_jvmdir}/jre
%ghost %{_bindir}/jjs
%ghost %{_bindir}/keytool
%ghost %{_bindir}/orbd
%ghost %{_bindir}/pack200
%ghost %{_bindir}/rmid
%ghost %{_bindir}/rmiregistry
%ghost %{_bindir}/servertool
%ghost %{_bindir}/tnameserv
%ghost %{_bindir}/unpack200
# headless of jdk 11/17
%else
# headless of jdk 11
%if %{majorver} < 12
%{_jvmdir}/%{sdkdir}/bin/pack200
%{_jvmdir}/%{sdkdir}/bin/rmid
%{_jvmdir}/%{sdkdir}/bin/jjs
%{_jvmdir}/%{sdkdir}/bin/unpack200
%dir %{_jvmdir}/%{sdkdir}/lib/jli
%{_jvmdir}/%{sdkdir}/lib/jli/libjli.so
%{_jvmdir}/%{sdkdir}/lib/libunpack.so
%{_jvmdir}/%{sdkdir}/lib/libsunec.so
%{_mandir}/man1/jjs-%{sdkdir}.1*
%{_mandir}/man1/pack200-%{sdkdir}.1*
%{_mandir}/man1/rmid-%{sdkdir}.1*
%{_mandir}/man1/unpack200-%{sdkdir}.1*
# headless of jdk 17
%else
%{_jvmdir}/%{sdkdir}/lib/libjli.so
%{_jvmdir}/%{sdkdir}/lib/libsyslookup.so
%ifarch x86_64
%{_jvmdir}/%{sdkdir}/lib/libjsvml.so
%endif
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/sdp
%config  %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/sdp/sdp.conf.template
%endif
# headless common
%license %{_jvmdir}/%{sdkdir}/legal
%dir %{_sysconfdir}/.java/.systemPrefs
%dir %{_sysconfdir}/.java
%dir %{_jvmdir}/%{sdkdir}
%{_jvmdir}/%{sdkdir}/release
%{_jvmdir}/%{jrelnk}
%dir %{_jvmdir}/%{sdkdir}/bin
%{_jvmdir}/%{sdkdir}/bin/java
%{_jvmdir}/%{sdkdir}/bin/keytool
%{_jvmdir}/%{sdkdir}/bin/rmiregistry
%dir %{_jvmdir}/%{sdkdir}/lib
%ifarch %{sa_arches}
%{_jvmdir}/%{sdkdir}/lib/classlist
%{_jvmdir}/%{sdkdir}/lib/libsaproc.so
%endif
%{_jvmdir}/%{sdkdir}/lib/jexec
%{_jvmdir}/%{sdkdir}/lib/jspawnhelper
%{_jvmdir}/%{sdkdir}/lib/jrt-fs.jar
%{_jvmdir}/%{sdkdir}/lib/modules
%{_jvmdir}/%{sdkdir}/lib/psfont.properties.ja
%{_jvmdir}/%{sdkdir}/lib/psfontj2d.properties
%{_jvmdir}/%{sdkdir}/lib/tzdb.dat
%{_jvmdir}/%{sdkdir}/lib/jvm.cfg
%{_jvmdir}/%{sdkdir}/lib/libattach.so
%{_jvmdir}/%{sdkdir}/lib/libawt.so
%{_jvmdir}/%{sdkdir}/lib/libextnet.so
%{_jvmdir}/%{sdkdir}/lib/libjsig.so
%{_jvmdir}/%{sdkdir}/lib/libawt_headless.so
%{_jvmdir}/%{sdkdir}/lib/libdt_socket.so
%{_jvmdir}/%{sdkdir}/lib/libfontmanager.so
%{_jvmdir}/%{sdkdir}/lib/libinstrument.so
%{_jvmdir}/%{sdkdir}/lib/libj2gss.so
%{_jvmdir}/%{sdkdir}/lib/libj2pcsc.so
%{_jvmdir}/%{sdkdir}/lib/libj2pkcs11.so
%{_jvmdir}/%{sdkdir}/lib/libjaas.so
%{_jvmdir}/%{sdkdir}/lib/libjava.so
%{_jvmdir}/%{sdkdir}/lib/libjavajpeg.so
%{_jvmdir}/%{sdkdir}/lib/libjdwp.so
%{_jvmdir}/%{sdkdir}/lib/libjimage.so
%{_jvmdir}/%{sdkdir}/lib/libjsound.so
%{_jvmdir}/%{sdkdir}/lib/liblcms.so
%{_jvmdir}/%{sdkdir}/lib/libmanagement.so
%{_jvmdir}/%{sdkdir}/lib/libmanagement_agent.so
%{_jvmdir}/%{sdkdir}/lib/libmanagement_ext.so
%{_jvmdir}/%{sdkdir}/lib/libmlib_image.so
%{_jvmdir}/%{sdkdir}/lib/libnet.so
%{_jvmdir}/%{sdkdir}/lib/libnio.so
%{_jvmdir}/%{sdkdir}/lib/libprefs.so
%{_jvmdir}/%{sdkdir}/lib/librmi.so
%{_jvmdir}/%{sdkdir}/lib/libsctp.so
%{_jvmdir}/%{sdkdir}/lib/libverify.so
%{_jvmdir}/%{sdkdir}/lib/libzip.so
%dir %{_jvmdir}/%{sdkdir}/lib/jfr
%{_jvmdir}/%{sdkdir}/lib/jfr/default.jfc
%{_jvmdir}/%{sdkdir}/lib/jfr/profile.jfc
%{_mandir}/man1/java-%{sdkdir}.1*
%{_mandir}/man1/keytool-%{sdkdir}.1*
%{_mandir}/man1/rmiregistry-%{sdkdir}.1*
%{_jvmdir}/%{sdkdir}/lib/server/
%ifarch %{sa_arches}
%attr(444, root, root) %ghost %{_jvmdir}/%{sdkdir}/lib/server/classes.jsa
%endif
%dir %{_sysconfdir}/java/%{name}
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/lib
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security
%{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/cacerts
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/conf
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/management
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/policy
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/policy/limited
%dir %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/policy/unlimited
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/default.policy
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/blocked.certs
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/lib/security/public_suffix_list.dat
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/policy/limited/exempt_local.policy
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/policy/limited/default_local.policy
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/policy/limited/default_US_export.policy
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/policy/unlimited/default_local.policy
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/policy/unlimited/default_US_export.policy
 %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/policy/README.txt
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/java.policy
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/security/java.security
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/logging.properties
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/management/jmxremote.access
%config  %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/management/jmxremote.password.template
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/management/management.properties
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/net.properties
%config(noreplace) %{_sysconfdir}/java/%{name}/%{sdkdir}/conf/sound.properties
%{_jvmdir}/%{sdkdir}/conf
%{_jvmdir}/%{sdkdir}/lib/security
%ghost %{_bindir}/java
%ghost %{_jvmdir}/jre
%ghost %{_bindir}/jjs
%ghost %{_bindir}/keytool
%ghost %{_bindir}/pack200
%ghost %{_bindir}/rmid
%ghost %{_bindir}/rmiregistry
%ghost %{_bindir}/unpack200
%ghost %{_jvmdir}/jre-konajdk
%ghost %{_jvmdir}/jre-%{majorver}
%ghost %{_jvmdir}/jre-%{majorver}-konajdk
%ghost %{_jvmdir}/%{sdkdir}/conf.rpmmoved
%ghost %{_jvmdir}/%{sdkdir}/lib/security.rpmmoved
%endif

%files devel
%defattr(-,root,root,-)
# java devel 8 special
%if %{majorver} < 9
%license %{_jvmdir}/%{sdkdir}/ASSEMBLY_EXCEPTION
%license %{_jvmdir}/%{sdkdir}/LICENSE
%license %{_jvmdir}/%{sdkdir}/THIRD_PARTY_README
%{_mandir}/man1/appletviewer-%{sdkdir}.1*
%{_mandir}/man1/extcheck-%{sdkdir}.1*
%{_mandir}/man1/idlj-%{sdkdir}.1*
%{_mandir}/man1/javah-%{sdkdir}.1*
%{_mandir}/man1/jhat-%{sdkdir}.1*
%{_mandir}/man1/jsadebugd-%{sdkdir}.1*
%{_mandir}/man1/native2ascii-%{sdkdir}.1*
%{_mandir}/man1/schemagen-%{sdkdir}.1*
%{_mandir}/man1/wsgen-%{sdkdir}.1*
%{_mandir}/man1/wsimport-%{sdkdir}.1*
%{_mandir}/man1/xjc-%{sdkdir}.1*
%{_jvmdir}/%{sdkdir}/lib/%{jdkarch}/*
%{_jvmdir}/%{sdkdir}/lib/ir.idl
%{_jvmdir}/%{sdkdir}/lib/jconsole.jar
%{_jvmdir}/%{sdkdir}/lib/orb.idl
%ifarch %{sa_arches}
%{_jvmdir}/%{sdkdir}/lib/sa-jdi.jar
%endif
%{_jvmdir}/%{sdkdir}/lib/dt.jar
%{_jvmdir}/%{sdkdir}/lib/tools.jar
%{_jvmdir}/%{sdkdir}/bin/appletviewer
%{_jvmdir}/%{sdkdir}/bin/clhsdb
%{_jvmdir}/%{sdkdir}/bin/extcheck
%{_jvmdir}/%{sdkdir}/bin/hsdb
%{_jvmdir}/%{sdkdir}/bin/idlj
%{_jvmdir}/%{sdkdir}/bin/java
%{_jvmdir}/%{sdkdir}/bin/javah
%{_jvmdir}/%{sdkdir}/bin/java-rmi.cgi
%{_jvmdir}/%{sdkdir}/bin/jhat
%{_jvmdir}/%{sdkdir}/bin/jjs
%{_jvmdir}/%{sdkdir}/bin/pack200
%{_jvmdir}/%{sdkdir}/bin/jsadebugd
%{_jvmdir}/%{sdkdir}/bin/keytool
%{_jvmdir}/%{sdkdir}/bin/rmid
%{_jvmdir}/%{sdkdir}/bin/rmic
%{_jvmdir}/%{sdkdir}/bin/native2ascii
%{_jvmdir}/%{sdkdir}/bin/orbd
%{_jvmdir}/%{sdkdir}/bin/policytool
%{_jvmdir}/%{sdkdir}/bin/schemagen
%{_jvmdir}/%{sdkdir}/bin/rmiregistry
%{_jvmdir}/%{sdkdir}/bin/servertool
%{_jvmdir}/%{sdkdir}/bin/tnameserv
%{_jvmdir}/%{sdkdir}/bin/unpack200
%{_jvmdir}/%{sdkdir}/bin/wsgen
%{_jvmdir}/%{sdkdir}/bin/wsimport
%{_jvmdir}/%{sdkdir}/bin/xjc
%ghost %{_bindir}/wsgen
%ghost %{_bindir}/wsimport
%ghost %{_bindir}/xjc
%{_mandir}/man1/rmic-%{sdkdir}.1*
%else
# java devel 11/17 special
%ifarch %{sa_arches}
%{_jvmdir}/%{sdkdir}/bin/jhsdb
%endif
%{_jvmdir}/%{sdkdir}/bin/jdeprscan
%{_jvmdir}/%{sdkdir}/bin/jimage
%{_jvmdir}/%{sdkdir}/bin/jlink
%{_jvmdir}/%{sdkdir}/bin/jmod
%{_jvmdir}/%{sdkdir}/bin/jshell
# java devel 11 special
%if %{majorver} < 12
%{_jvmdir}/%{sdkdir}/bin/jaotc
%{_jvmdir}/%{sdkdir}/bin/rmic
%{_mandir}/man1/rmic-%{sdkdir}.1*
# java devel 17 special
%else
%{_jvmdir}/%{sdkdir}/bin/jpackage
%{_mandir}/man1/jpackage-%{sdkdir}.1*
%{_mandir}/man1/jdeprscan-%{sdkdir}.1*
%{_mandir}/man1/jlink-%{sdkdir}.1*
%{_mandir}/man1/jmod-%{sdkdir}.1*
%{_mandir}/man1/jshell-%{sdkdir}.1*
%{_mandir}/man1/jfr-%{sdkdir}.1*
%{_mandir}/man1/jhsdb-%{sdkdir}.1*
%endif
%endif
# java devel common
%dir %{_jvmdir}/%{sdkdir}/bin
%dir %{_jvmdir}/%{sdkdir}/include
%dir %{_jvmdir}/%{sdkdir}/lib
%{_jvmdir}/%{sdkdir}/bin/jar
%{_jvmdir}/%{sdkdir}/bin/jarsigner
%{_jvmdir}/%{sdkdir}/bin/javac
%{_jvmdir}/%{sdkdir}/bin/javadoc
%{_jvmdir}/%{sdkdir}/bin/javap
%{_jvmdir}/%{sdkdir}/bin/jcmd
%{_jvmdir}/%{sdkdir}/bin/jconsole
%{_jvmdir}/%{sdkdir}/bin/jdb
%{_jvmdir}/%{sdkdir}/bin/jdeps
%{_jvmdir}/%{sdkdir}/bin/jfr
%{_jvmdir}/%{sdkdir}/bin/jinfo
%{_jvmdir}/%{sdkdir}/bin/jmap
%{_jvmdir}/%{sdkdir}/bin/jps
%{_jvmdir}/%{sdkdir}/bin/jrunscript
%{_jvmdir}/%{sdkdir}/bin/jstack
%{_jvmdir}/%{sdkdir}/bin/jstat
%{_jvmdir}/%{sdkdir}/bin/jstatd
%{_jvmdir}/%{sdkdir}/bin/serialver
%{_jvmdir}/%{sdkdir}/include/*
%{_jvmdir}/%{sdkdir}/lib/ct.sym
%{_jvmdir}/%{sdkdir}/lib/jexec
%{_mandir}/man1/jar-%{sdkdir}.1*
%{_mandir}/man1/jarsigner-%{sdkdir}.1*
%{_mandir}/man1/javac-%{sdkdir}.1*
%{_mandir}/man1/javadoc-%{sdkdir}.1*
%{_mandir}/man1/javap-%{sdkdir}.1*
%{_mandir}/man1/jconsole-%{sdkdir}.1*
%{_mandir}/man1/jcmd-%{sdkdir}.1*
%{_mandir}/man1/jdb-%{sdkdir}.1*
%{_mandir}/man1/jdeps-%{sdkdir}.1*
%{_mandir}/man1/jinfo-%{sdkdir}.1*
%{_mandir}/man1/jmap-%{sdkdir}.1*
%{_mandir}/man1/jps-%{sdkdir}.1*
%{_mandir}/man1/jrunscript-%{sdkdir}.1*
%{_mandir}/man1/jstack-%{sdkdir}.1*
%{_mandir}/man1/jstat-%{sdkdir}.1*
%{_mandir}/man1/jstatd-%{sdkdir}.1*
%{_mandir}/man1/serialver-%{sdkdir}.1*
%ghost %{_jvmdir}/java
%ghost %{_bindir}/appletviewer
%ghost %{_bindir}/clhsdb
%ghost %{_bindir}/extcheck
%ghost %{_bindir}/hsdb
%ghost %{_bindir}/idlj
%ghost %{_bindir}/jar
%ghost %{_bindir}/jarsigner
%ghost %{_bindir}/java
%ghost %{_bindir}/java-rmi.cgi
%ghost %{_bindir}/javac
%ghost %{_bindir}/javadoc
%ghost %{_bindir}/javah
%ghost %{_bindir}/javap
%ghost %{_bindir}/jcmd
%ghost %{_bindir}/jconsole
%ghost %{_bindir}/jdb
%ghost %{_bindir}/jdeps
%ghost %{_bindir}/jhat
%ghost %{_bindir}/jinfo
%ghost %{_bindir}/jjs
%ghost %{_bindir}/jmap
%ghost %{_bindir}/jps
%ghost %{_bindir}/jrunscript
%ghost %{_bindir}/jsadebugd
%ghost %{_bindir}/jstack
%ghost %{_bindir}/jstat
%ghost %{_bindir}/jstatd
%ghost %{_bindir}/keytool
%ghost %{_bindir}/native2ascii
%ghost %{_bindir}/orbd
%ghost %{_bindir}/pack200
%ghost %{_bindir}/policytool
%ghost %{_bindir}/rmic
%ghost %{_bindir}/rmid
%ghost %{_bindir}/rmiregistry
%ghost %{_bindir}/schemagen
%ghost %{_bindir}/serialver
%ghost %{_bindir}/servertool
%ghost %{_bindir}/tnameserv
%ghost %{_bindir}/unpack200

%if %{majorver} > 8
%files jmods
%{_jvmdir}/%{sdkdir}/jmods
%endif

%files demo
%defattr(-,root,root,-)
%{_jvmdir}/%{sdkdir}/demo
%if %{majorver} < 9
%license %{_jvmdir}/%{sdkdir}/jre/LICENSE
%{_jvmdir}/%{sdkdir}/sample
%else
%license %{_jvmdir}/%{sdkdir}/legal
%endif

%files src
%defattr(-,root,root,-)
%if %{majorver} < 9
%doc README.md
%{_jvmdir}/%{sdkdir}/src.zip
%else
%license %{_jvmdir}/%{sdkdir}/legal
%{_jvmdir}/%{sdkdir}/lib/src.zip
%endif


%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}
%ghost %{_javadocdir}/java
%if %{majorver} < 9
%license %{debug_level}/images/%{jdkimage}/jre/LICENSE
%else
%license %{_jvmdir}/%{sdkdir}/legal
%endif

%files javadoc-zip
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{sdkdir}.zip
%if %{majorver} < 9
%license %{debug_level}/images/%{jdkimage}/jre/LICENSE
%else
%license %{_jvmdir}/%{sdkdir}/legal
%ghost %{_javadocdir}/java-zip
%endif



%changelog
* Fri Nov 01 2024 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.20-1
- Updated to upstream version 8.0.20
- fixed CVE-2024-21235 CVE-2024-21208 CVE-2024-21210 CVE-2024-21217

* Mon Oct 14 2024 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.19-1
- Updated to upstream version 8.0.19
- fixed CVE-2024-21147 CVE-2024-21145 CVE-2024-21140 CVE-2024-21144
-       CVE-2024-21131 CVE-2024-21138

* Sun Sep 29 2024 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.18-4
- limited building architechture in x86_64 and aarch64

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.18-3
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.18-2
- Rebuilt for loongarch release

* Mon Jun 24 2024 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.18-1
- updated to upstream 8.0.18
- fixed CVE-2024-21094 CVE-2024-21085 CVE-2024-21011 CVE-2024-21068

* Wed Mar 20 2024 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.17-1
- updated to upstream 8.0.17
- fixed CVE-2024-20918 CVE-2024-20952 CVE-2024-20926 CVE-2024-20919 CVE-2024-20921
-       CVE-2024-20945

* Fri Dec 15 2023 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.16-2
- fixed java -version display wrong version number 

* Wed Nov 01 2023 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.16-1
- updated to upstream 8.0.16
- disabled building debug package

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.13-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.13-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.0.13-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Feb 22 2023 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.13-1
- updated to upstream 8.0.13
- changed default jdk version to 17

* Wed Feb 22 2023 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.9-5
- fixed headless postun script

* Fri Feb 10 2023 Xin Cheng <denisecheng@tencent.com> - 8.0.9-4
- Fix noarch package built differently on different architectures

* Thu Nov 24 2022 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.9-3
- added java-1.8.0 and jre-1.8.0 directories for adapting openjdk

* Wed Jun 29 2022 Zhao Zhen <jeremiazhao@tencent.com> - 8.0.9-2
- add subpackage of konajdk for rpm-based OS
- add alternatives supports for multiversion of jdk
- add bootstrap supoort for OS
- let 8/11/17 all-in-one spec files
- remove epoch
- add multi arch supports initially
- add some capability compatibility with openjdk
- add nss in depends avoiding some bugs
- simplify macros and Scriptlets

* Wed Feb 16 2022 seanwxiang <seanwxiang@tencent.com> - 8.0.9-1.1.322
- Update to jdk-8u322
- Vectorize UTF-8 encode
- Fix: FreeHeapPhysicalMemory period check use wrong time unit

* Thu Nov 18 2021 tobytbzhang <tobytbzhang@tencent.com> - 8.0.8-1.1.312
- Update to jdk-8u312
- Vectorize UTF-8 decode
- Support asynchronous GC logging
- JDK-8175318: Performance issue regarding local JNI references
- JDK-8183369: RFC unconformity of HttpURLConnection with proxy
- Revert CMSParallelFullGC
- Revert ArrayAllocationWarningSize
